<template>
  <div class="d-flex align-center" :style="'min-height:' + maxHeight + 'px;'">
    <v-row>
      <v-col
        :class="[
          {
            'd-flex':
              ($vuetify.breakpoint.name === 'sm' ||
                $vuetify.breakpoint.name === 'xl') &&
              !loadingContent,
          },
        ]"
        class="text-center pb-0 pt-0 align-center"
        sm="6"
        md="12"
        lg="12"
        xl="7"
        cols="12"
      >
        <template v-if="loadingContent">
          <v-skeleton-loader type="image" />
        </template>
        <template v-else>
          <div style="min-width: 250px; min-height:160px;" ref="chart" />
        </template>
      </v-col>
      <v-col
        class="pt-0"
        :class="{ 'd-flex align-center': !loadingContent }"
        sm="6"
        md="12"
        lg="12"
        xl="5"
        cols="12"
      >
        <template v-if="loadingContent">
          <v-skeleton-loader class="mt-3" type="paragraph" />
        </template>
        <template v-else>
          <v-row>
            <template v-for="(item, index) in data.values">
              <v-col
                :key="index"
                sm="12"
                md="12"
                lg="12"
                xl="12"
                cols="12"
                class="text-center"
              >
                <strong class="text-h6 font-weight-black">{{
                  item.leyeda
                }}</strong>
                <div>
                  <strong class="text-h4 font-weight-black">{{
                    item.value
                  }}</strong>
                </div>
              </v-col>
            </template>
          </v-row>
        </template>
      </v-col>
    </v-row>
  </div>
</template>
<script>
import * as am4core from "@amcharts/amcharts4/core";
import * as am4charts from "@amcharts/amcharts4/charts";
import am4themes_animated from "@amcharts/amcharts4/themes/animated";
am4core.useTheme(am4themes_animated);
export default {
  name: "Component-Odometro",
  props: {
    loadingContent: {
      required: false,
      default: false,
      type: Boolean,
    },
    height: {
      required: false,
      default: 225,
      type: [Number, String],
    },
    data: {
      required: true,
      default() {
        return {
          title: null,
          total: 0,
          color: null,
          values: [],
        };
      },
      type: Object,
    },
  },
  data() {
    return {
      chart: null,
    };
  },
  watch: {
    loadingContent(value) {
      if (!value) {
        this.renderChart();
      }
    },
    color(val) {
      if (val) {
        this.renderChart();
      }
    },
  },
  computed: {
    color() {
      return this.data.color;
    },
    maxHeight() {
      if (this.$vuetify.breakpoint.name === "lg") {
        return 350;
      } else if (this.$vuetify.breakpoint.name === "md") {
        return 252;
      } else {
        return 181;
      }
    },
  },
  methods: {
    buildChart() {
      let chart = this.chart;
      chart.logo.dom.style.display = "none";

      chart.hiddenState.properties.opacity = 0;
      chart.innerRadius = am4core.percent(75);

      var axis = chart.xAxes.push(new am4charts.ValueAxis());
      axis.min = 0;
      axis.max = 100;
      axis.strictMinMax = true;
      axis.renderer.minGridDistance = 10000;
      axis.renderer.labels.template.fontSize = 20;
      axis.renderer.labels.template.hidden = true;
      axis.renderer.grid.template.strokeWidth = 3;
      axis.renderer.grid.template.stroke = new am4core.InterfaceColorSet().getFor(
        "background"
      );
      axis.renderer.grid.template.strokeOpacity = 1;

      var range0 = axis.axisRanges.create();
      range0.value = 0;
      range0.endValue = this.data.total;
      range0.axisFill.fillOpacity = 1;
      range0.axisFill.fill = this.color;
      range0.axisFill.zIndex = -1;

      var rangeDiff = axis.axisRanges.create();
      rangeDiff.value = this.data.total;
      rangeDiff.endValue = 100;
      rangeDiff.axisFill.fillOpacity = 1;
      rangeDiff.axisFill.fill = "#E0E0E0";
      rangeDiff.axisFill.zIndex = -1;

      var label = chart.radarContainer.createChild(am4core.Label);
      label.isMeasured = false;
      label.fontSize = 55;
      label.fontFamily = "Avenir_Next_Demi_Bold";
      label.y = 15;
      label.horizontalCenter = "middle";
      label.verticalCenter = "bottom";
      label.text = this.data.total;

      var label0 = chart.radarContainer.createChild(am4core.Label);
      label0.isMeasured = false;
      label0.fontSize = 15;
      label0.fontFamily = "Avenir_Next_Demi_Bold";
      label0.y = 0;
      label0.fill = "#757575";
      label0.horizontalCenter = "middle";
      label0.verticalCenter = "top";
      label0.text = "0";

      label0.adapter.add("x", function(x, target) {
        return -(
          axis.renderer.pixelInnerRadius +
          (axis.renderer.pixelRadius - axis.renderer.pixelInnerRadius) / 2
        );
      });

      var label1 = chart.radarContainer.createChild(am4core.Label);
      label1.isMeasured = false;
      label1.fontSize = 15;
      label1.fontFamily = "Avenir_Next_Demi_Bold";
      label1.y = 0;
      label1.fill = "#757575";
      label1.horizontalCenter = "middle";
      label1.verticalCenter = "top";
      label1.text = "100";

      label1.adapter.add("x", function(x, target) {
        return (
          axis.renderer.pixelInnerRadius +
          (axis.renderer.pixelRadius - axis.renderer.pixelInnerRadius) / 2
        );
      });
    },
    renderChart() {
      this.$nextTick(() => {
        this.disposeChart();
        let chart = this.$refs.chart;
        this.chart = am4core.create(chart, am4charts.GaugeChart);
        this.buildChart();
      });
    },
    disposeChart() {
      if (this.chart) {
        this.chart.dispose();
      }
    },
  },
  beforeDestroy() {
    this.disposeChart();
  },
  mounted() {
    if (!this.chart) {
      this.renderChart();
    }
  },
};
</script>
